unit MainUnit;

interface

uses
  SysInfo,  //testing module
  Windows,  //types, const.
  SysUtils,
  Forms,
  ComCtrls,
  Controls,
  StdCtrls,
  Classes;

type
  TMainForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Memo4: TMemo;
    Memo5: TMemo;
    Memo6: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    ButtonHP: TButton;
    procedure TabSheet1Show(Sender: TObject);
    procedure TabSheet2Show(Sender: TObject);
    procedure TabSheet3Show(Sender: TObject);
    procedure TabSheet4Show(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ButtonHPClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.Button1Click(Sender: TObject);
var
   PrEn : TProcEntryArray;
   K,I  : Integer;
begin
   Memo5.Clear;
   K := GetProcessesEx_TlHelp32 (PrEn);
   with Memo5.Lines do
   begin
     If K > 0 then
     begin
       Add('Run now: ' + IntToStr(K));
       Add('');
       for I := 0 to K - 1 do
       begin
         Add('#' + IntToStr(I+1) + ' '
         + 'Proc. Name: ' + PrEn[I].szExeFile);
         Add('Proc. th32ID: ' + IntToStr(PrEn[I].th32ProcessID));
         //Add('Record size: ' + IntToStr(PrEn[I].dwSize));
         //Add('Count of Usage: ' + IntToStr(PrEn[I].cntUsage));
         //Add('Heap ID - ' + IntToStr(PrEn[I].th32DefaultHeapID));
         //Add('Module ID - ' + IntToStr(PrEn[I].th32ModuleID));
         Add('Count of Threads: ' + IntToStr(PrEn[I].cntThreads));
         Add('Parent ID - ' + IntToStr(PrEn[I].th32ParentProcessID));
         Add('Priority Base Class: ' + IntToStr(PrEn[I].pcPriClassBase));
         //Add('Flags (not used): ' + IntToStr(PrEn[I].dwFlags));
         Add('');
         Add('==============================');
         Add('');
       end;
     end else Add('Error in GetProcessesEx_TlHelp32()');
   end;
   PrEn := Nil;
end;

procedure TMainForm.Button2Click(Sender: TObject);
var
   Proc: TProcArray;
   K,I: Word;
begin
   Memo5.Clear;
   K:=GetProcessesList_TlHelp32 ( Proc );
   If K > 0 then
   begin
     Memo5.Lines.Add('Processes run: ' + IntToStr(K));
     Memo5.Lines.Add('');
     For I:=0 to K-1 do Memo5.Lines.Add(
     '#' + IntToStr(I+1) + ' ' + Proc[I]);
   end
   else Memo5.Lines.Add('Error in GetProcessesList_TlHelp32()');
   Proc:=Nil;
end;

procedure TMainForm.Button3Click(Sender: TObject);
var
  ProcsInfo: TProcsInfoArray;
  I,K,J: Integer;
begin
  K:=GetProcessesExNT_Psapi(ProcsInfo);
  Memo6.Clear;
  with Memo6.Lines do
  begin //with begins
      If K > 0 then
      begin
      Add('Procs. run: ' + IntToStr(K));
      Add('');
      for I := 0 to K - 1 do
      begin
        Add('#' + IntToStr(I+1) + ' '
           + ProcsInfo[I].ProcName
           + ' ( ID = ' + IntToStr(ProcsInfo[I].ProcID) + ' )');
        Add('Full Path: ' + ProcsInfo[I].ProcPath);
        if ProcsInfo[I].ErrorCodes[2] = 0 then
        begin
             Add('----------------- ');
             Add('Memory Counters:');
             Add('PageFaultCount = '
             + IntToStr(ProcsInfo[I].MemCounters.PageFaultCount));
             Add('PeakWorkingSetSize = '
             + IntToStr(ProcsInfo[I].MemCounters.PeakWorkingSetSize));
             Add('WorkingSetSize = '
             + IntToStr(ProcsInfo[I].MemCounters.WorkingSetSize));
             Add('QuotaPeakPagedPoolUsage = '
             + IntToStr(ProcsInfo[I].MemCounters.QuotaPeakPagedPoolUsage));
             Add('QuotaPagedPoolUsage = '
             + IntToStr(ProcsInfo[I].MemCounters.QuotaPagedPoolUsage));
             Add('QuotaPeakNonPagedPoolUsage = '
             + IntToStr(ProcsInfo[I].MemCounters.QuotaPeakNonPagedPoolUsage));
             Add('QuotaNonPagedPoolUsage = '
             + IntToStr(ProcsInfo[I].MemCounters.QuotaNonPagedPoolUsage));
             Add('PagefileUsage = '
             + IntToStr(ProcsInfo[I].MemCounters.PagefileUsage));
             Add('PeakPagefileUsage = '
             + IntToStr(ProcsInfo[I].MemCounters.PeakPagefileUsage));
        end else Add('Memory Counters: Unknown');
        for J := 0 to 4 do
        if ProcsInfo[I].ErrorCodes[J] <> 0 then
        Add('>>>ERROR CODE [' + IntToStr(J) + '] : '
        + IntToStr(ProcsInfo[I].ErrorCodes[J]));
        Add('');
      end; //for I ends
      if ButtonHP.Enabled then Add('(IF MANY "Errors" TRY High Priv.)');
      end else Add('Error in GetProcessesExNT_Psapi()');
  end; //with ends
  ProcsInfo := Nil;
end; 

procedure TMainForm.Button4Click(Sender: TObject);
var
   Proc: TProcArray;
   K,I: Word;
   S: String;
begin
   Memo6.Clear;
   if Sender = Button4 then
   begin
     K := GetProcessesPathsNT_Psapi ( Proc );
     S := 'Error in GetProcessesPathsNT_Psapi()';
   end
   else
   begin
     K := GetProcessesNamesNT_Psapi ( Proc );
     S := 'Error in GetProcessesNamesNT_Psapi()';
   end;

   with Memo6.Lines do
   If K > 0 then
   begin
     Add('Processes run: ' + IntToStr(K));
     Add('');
     For I:=0 to K-1 do Add('#'+IntToStr(I+1)+' '+ Proc[I]);
     Add('');
     if ButtonHP.Enabled then Add('(IF MANY "Errors" TRY High Priv.)');
   end else Add(S);

   Proc:=Nil; //free mem.
end;

procedure TMainForm.Button6Click(Sender: TObject);
var
   ids: TProcsIDs;
   h: Array of Cardinal;
   k,i: Word;
   b: Boolean;
begin
   Memo6.Clear;
   with Memo6.Lines do
   begin
     k := GetProcessesIDs_Psapi(ids);
     if k > 0  then
     try
       SetLength(h,k);
     except
       h := Nil;
       ids := Nil;
       Add('Error');
       exit;
     end
     else begin Add('Error in GetProcessesIDs_Psapi()'); exit; end;

     Add('GetProcessesIDs_Psapi() and GetProcessHandleByID():');
     Add('');
     for i := 0 to k-1 do
     begin
       h[i]:= GetProcessHandleByID(ids[i]);
       Add('Proc. # ' + IntToStr(i+1) + ' ID '+ IntToStr(ids[i])
       + ' Handle ' + IntToStr(h[i]));
     end;
     Add('');
     Add('After CloseHandleAndNull():');
     Add('');
     b:=true;
     for i := 0 to k-1 do
     if not CloseHandleAndNull(h[i]) then
     begin
       Add('Proc. # ' + IntToStr(i+1) + ' ID ' + IntToStr(ids[i])
       + ' Handle ' + IntToStr(h[i]) + ' -> Error in CloseHandleAndNull()');
       b:=false;
     end;
     if b then Add('All handles closed and set to 0');
   end;
   ids:=Nil;
   h:=Nil;
end;

procedure TMainForm.ButtonHPClick(Sender: TObject);
begin
  TrySetHighPriv;
  ButtonHP.Enabled:=False;
end;

procedure TMainForm.TabSheet1Show(Sender: TObject);
var
  VI : TOSVersionInfo;
  str,str2: String;
  Des: TOSDescription;
begin
  Memo1.Clear;
  With Memo1.Lines do
  begin
    Add('>> Result of GetOSAndPlatformInfo():');
    if GetOSAndPlatformInfo(VI) then
    begin
       str:='OS Version: ' + IntToStr(VI.dwMajorVersion)
       + '.' + IntToStr(VI.dwMinorVersion) +'(';
       If Vi.dwPlatformId = 1 then //Win9x/Me
       str:=str+IntToStr(Word(VI.dwBuildNumber))
       else str:=str+IntToStr(VI.dwBuildNumber);
       Add(str+')');
       Add('Addition Info: ' + VI.szCSDVersion);
       Case VI.dwPlatformId of
         VER_PLATFORM_WIN32s :
           str:='Win32s on Windows 3.1';
         VER_PLATFORM_WIN32_WINDOWS :
           str:='Win32 on Windows 95/98/Me';
         VER_PLATFORM_WIN32_NT :
           str:='Win32NT on Windows NT/2000/XP/Server 2003 family';
         VER_PLATFORM_WIN32_CE :
           str:='Win32CE'
       else str:='Unknown Platform';
       end;
       Add('Platform: ' + IntToStr(VI.dwPlatformId) + ' ( '+str+' )');
    end
    else Add('Error in  GetOSAndPlatformInfo');
    Add('');
    Add('>> Result of GetSystemDefaultLanguage:');
    Add('Language: ' + GetSystemDefaultLanguage);
    Add('');
    Add('>> Result of GetOSRegInfo():');
    If GetOSRegInfo(Des) then
    begin
       Add('OS / Build: ' + Des.Name + '   /   ' + Des.BuildNumber);
       Add('ID: ' + Des.ID);
       Add('Addition Info: ' + Des.CSDVersion + ' (' + Des.CSDBuildNumber+')');
    end
    else Add('Error in  GetOSRegInfo');
    Add('');
    Add('>> Results of GetWindowsDir(), GetSystemDir() and GetCurrentDir():');
    Add('Win Dir: ' + GetWindowsDir);
    Add('Sys Dir: ' + GetSystemDir);
    Add('Current Dir: '+ GetCurrentDir);
    Add('');
    Add('>> Results of GetUser and GetCompName: ');
    Add('User Name: ' + GetUser);
    Add('Computer Name: ' + GetCompName);
    Add('');
    Add('>> Result of GetRegInfo(): ');
    if GetRegInfo ( str, str2 ) then
    begin
      Add('Registered Owner: ' + str);
      Add('Registered Organization: ' + str2);
    end
    else Add('Error in GetRegInfo()');
    end;
end;

procedure TMainForm.TabSheet2Show(Sender: TObject);
var
  str : String;
  I : Char;
  K,J : Integer;
  DI : TDrivesInfoArray;
  PCD : TPrinterConstsDescriptions;
  Prs : TPrintersArray;
  PrsInfo : TPrintersInfoArray;
  F : Word;
  PF : TProcessorFeatures;
begin
  Memo2.Clear;
  With Memo2.Lines do
  begin
    Add('>> Result of work GetDrive() with GetDriveSize() functions:');
    str:='Drives: ';
    for I:='A' to 'Z' do
    if GetDriveTypeInfo(I+':') <> 'None' then
    str:= str + I + ': ('
    + GetDriveTypeInfo(I+':'+'\')
    + ', ' + IntToStr(GetDriveSize(BYTE(I)-BYTE('A')+1))+ ' MB'
    +'), ';
    SetLength(str,Length(str)-2);
    Add(str);
    Add('Current drive size: ' + IntToStr(GetDriveSize(0)) + ' MB');
    Add('');
    Add('>> Result of GetVideoCard:');
    Add('Video Card: ' + GetVideoCard);
    Add('');
    K := GetPresentDrivesInfo(DI);
    Add('>> Result of GetPresentDrivesInfo():');
    if K > 0 then
    begin
      Add('Drives count: ' + IntToStr(K));
      str:='Drives: ';
      for J := 0 to K - 1 do  str := str
      + DI[J].DName + ' ('+ DI[J].DType +', ' + DI[J].DSize + '), ';
      SetLength(str,Length(str)-2);
      Add(str);
    end else Add('Error in GetPresentDrivesInfo()');
    Add('');
    Add('>> Results of GetPrinters() and GetDefaultPrinter:');
    K := GetPrinters (Prs);
    If K > 0 then
    begin
      Add ('All Printers: ' + IntToStr(K));
      for J := 0 to K - 1 do Add(Prs[J]);
    end else Add('Error in GetPrinters()');
    Add('Default Printer: ' + GetDefaultPrinter);
    Add('');
    Add('>> Result of GetPrintersEx():');
    //You can change strings of PCD, for example:
    //PCD.PORTRAIT_Orientation  := 'PORTRAIT';
    //PCD.LANDSCAPE_Orientation := 'LANDSCAPE';
    //But here I leave them default.
    K := GetPrintersEx ( PCD, PrsInfo );
    If K > 0 then
    begin
      Add ('All Printers: ' + IntToStr(K));
      for J := 0 to K - 1 do
      begin
        Add ('#' + IntToStr(J+1) + ' :');
        Add ('   Name: ' + PrsInfo[J].Name);
        Add ('   "Friendly" Name: ' + PrsInfo[J].FriendlyName);
        Add ('   Port: ' + PrsInfo[J].Port);
        Add ('   Print Processor: ' + PrsInfo[J].Processor);
        Add ('   Form Name: ' + PrsInfo[J].FormName);
        Add ('   Paper orient.: ' + PrsInfo[J].Orientation);
        If PrsInfo[J].XResolutionOrQuality > 0 then
        Add ('   X Resolution: '
        + IntToStr(PrsInfo[J].XResolutionOrQuality)
        + ' dpi')
        else Add ('   Print Quality const: '
        + IntToStr(PrsInfo[J].XResolutionOrQuality));
        Add ('   Y Resolution: ' + IntToStr(PrsInfo[J].YResolution) + ' dpi');
        Add ('   Driver Name: ' + PrsInfo[J].Driver);
        Add ('   Driver Version: ' + IntToStr(PrsInfo[J].DriverVersion));
        Add ('   Data Type: ' + PrsInfo[J].DataType);
        Add ('   Method of printing TTF: ' + PrsInfo[J].TrueTypeMethod);
      end;
    end else Add('Error in GetPrintersEx()');  
    Add('');
    Add('>> Result of GetProcessorLevel():');
    Add('Processor Level: ' + IntToStr(GetProcessorLevel(str))+ ' ('+str+')');
    Add('');
    Add('>> Result of CalcCPUFreq():');
    F:= CalcCPUFreq(777,77);
    if F <> 0 then
    Add('CPU frec. (maybe wrong): ' + IntToStr(F)+' MHz')  
    else Add('Error in CalcCPUFreq()');
    Add('');
    Add('>> Result of TryDetectProcessorFeatures():');
    if TryDetectProcessorFeatures (PF) then
    begin
      Add('');
      Add('Can detect following processor features:');
      if PF.pf3DNow then Add('3D-Now instruction set');
      if PF.pfChannels then Add('Channels');
      if PF.pfCmpXChg then Add('CmpXChg');
      if PF.pfCmpXChg16b then Add('CmpXChg16b');
      if PF.pfCmp8XChg16 then Add('Cmp8XChg16');
      if PF.pfFloatEmul then Add('Floating-point operations emul.');
      if PF.pfFloatPrecErrata then
      Add('Floating-point precision error can occur in rare circumstances');
      if PF.pfMMX then Add('MMX instruction set');
      if PF.pfNX then Add('Data execution prevention');
      if PF.pfPAE then Add('PAE');
      if PF.pfRDTSC then Add('RDTSC instruction');
      if PF.pfSSE3 then Add('SSE3 instruction set');
      if PF.pfSSE2 then Add('SSE2 instruction set');
      if PF.pfSSE then Add('SSE instruction set');
      if PF.pfXSAVE then Add('XSAVE and XRSTOR instructions');
    end else  Add('Error in TryDetectProcessorFeatures()');
  end;
//free mem.:
DI := Nil;
Prs := Nil;
PrsInfo := Nil;
end;

procedure TMainForm.TabSheet3Show(Sender: TObject);
var
  MS : TMemoryStatus;
  MSx : TMemStatEx;
begin
Memo3.Clear;
with Memo3.Lines do
begin
   Add('>> Result of GetGlobalMemoryStatus():');
   if GetGlobalMemoryStatus(MS) then
   begin
      Add('Memory Usage: ' + IntToStr(MS.dwMemoryLoad) + ' %');
      Add('RAM: ' + IntToStr(MS.dwTotalPhys shr 20) + ' MB');
      Add('Free RAM: ' + IntToStr(MS.dwAvailPhys div 1024 div 1024) + ' MB');
      Add('Committed memory limit: '
      + IntToStr(MS.dwTotalPageFile div 1024 div 1024) + ' MB');
      Add('Available memory to commit: '
      + IntToStr(MS.dwAvailPageFile div 1024 div 1024) + ' MB');
      Add('Virtual: ' + IntToStr(MS.dwTotalVirtual div 1024 div 1024) + ' MB');
      Add('Free Virtual: ' + IntToStr(MS.dwAvailVirtual div 1024 div 1024)+' MB');
      Add('');
      Add('NOTE: On PC with more 2GB Data from GetGlobalMemoryStatus()');
      Append('maybe Incorrect...');
   end
   else Add('Error in GetGlobalMemoryStatus()');
   Add('');
   Add('>> Result of GetGlobalMemoryStatusEx():');
   if GetGlobalMemoryStatusEx(MSx) then
   try
      Add('Memory Usage: ' + IntToStr(MSx.dwMemoryLoad) + ' %');
      Add('RAM: ' + IntToStr(Int64(MSx.ullTotalPhys) shr 20) + ' MB');
      Add('Free RAM: ' + IntToStr(Int64(MSx.ullAvailPhys) shr 20) + ' MB');
      Add('Committed memory limit: '
      + IntToStr(Int64(MSx.ullTotalPageFile) shr 20) + ' MB');
      Add('Available memory to commit: '
      + IntToStr(Int64(MSx.ullAvailPageFile) shr 20) + ' MB');
      Add('Virtual: ' + IntToStr(Int64(MSx.ullTotalVirtual) shr 20) + ' MB');
      Add('Free Virtual: '+IntToStr(Int64(MSx.ullAvailVirtual) shr 20)+' MB');
   except
      Add('Probably conversion to Int64 overflow error..');
   end
   else Add('Error in GetGlobalMemoryStatusEx()');
end;
end;

procedure TMainForm.TabSheet4Show(Sender: TObject);
var
  Perf : TPerfInfo;
  PerfM : TPerfInfoModified;
begin
  Memo4.Clear;
  with Memo4.Lines do
  begin
  Add('>> Result of GetPerfInfo():');
  If GetPerfInfo(Perf) then
  begin
    Add('');
    Add('Proc. count = '+IntToStr(Perf.ProcessCount));
    Add('Thread count = '+IntToStr(Perf.ThreadCount));
    Add('Handle count = '+IntToStr(Perf.HandleCount));
    Add('');
    Add('RAM (in pages) = '+IntToStr(Perf.PhysicalTotal));
    Add('Page size (Byte) = '+IntToStr(Perf.PageSize));
    Add('RAM (MB) = '
    + IntToStr(Perf.PhysicalTotal*Perf.PageSize shr 20)); //instead of devision
    Add('');
    Add('Params. in pages:');
    Add('CommitTotal = ' + IntToStr(Perf.CommitTotal));
    Add('CommitLimit = ' + IntToStr(Perf.CommitLimit));
    Add('CommitPeak = ' + IntToStr(Perf.CommitPeak));
    Add('PhysicalAvailable = ' + IntToStr(Perf.PhysicalAvailable));
    Add('SystemCache = ' + IntToStr(Perf.SystemCache));
    Add('KernelTotal = ' + IntToStr(Perf.KernelTotal));
    Add('KernelPaged = ' + IntToStr(Perf.KernelPaged));
    Add('KernelNonpaged = ' + IntToStr(Perf.KernelNonpaged));
  end
  else Add('Error in GetPerfInfo()');
  Add('');
  Add('>> Result of GetPerfInfoModified():');
  If GetPerfInfoModified(PerfM) then
  begin
    Add('');
    Add('Proc. count:  ' + IntToStr(PerfM.ProcessCount));
    Add('Thread count: ' + IntToStr(PerfM.ThreadCount));
    Add('Handle count: ' + IntToStr(PerfM.HandleCount));
    Add('');
    Add('RAM (in MB):     ' + IntToStr(PerfM.PhysicalTotal));
    Add('Av. RAM (in MB): ' + IntToStr(PerfM.PhysicalAvailable));
    Add('');
    Add('CommitTotal (MB) = ' + IntToStr(PerfM.CommitTotal));
    Add('CommitLimit (MB) = ' + IntToStr(PerfM.CommitLimit));
    Add('CommitPeak  (MB) = ' + IntToStr(PerfM.CommitPeak));
    Add('SystemCache (MB) = ' + IntToStr(PerfM.SystemCache));
    Add('KernelTotal (MB) = ' + IntToStr(PerfM.KernelTotal));
    Add('KernelPaged (MB) = ' + IntToStr(PerfM.KernelPaged));
    Add('KernelNonp. (MB) = ' + IntToStr(PerfM.KernelNonpaged));
  end
  else Add('Error in GetPerfInfoModified()');
  end;
end;

end.
