unit helper;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//             Help file for SysInfo functions implementation                 //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

interface

const

  UNLEN = 256;
  PROCESSOR_ARCHITECTURE_INTEL = 0;
  PF_3DNOW_INSTRUCTIONS_AVAILABLE = 7;
  PF_CHANNELS_ENABLED = 16;
  PF_COMPARE_EXCHANGE_DOUBLE = 2;
  PF_COMPARE_EXCHANGE128 = 14;
  PF_COMPARE64_EXCHANGE128 = 15;
  PF_FLOATING_POINT_EMULATED = 1;
  PF_FLOATING_POINT_PRECISION_ERRATA = 0;
  PF_MMX_INSTRUCTIONS_AVAILABLE = 3;
  PF_NX_ENABLED = 12;
  PF_PAE_ENABLED = 9;
  PF_RDTSC_INSTRUCTION_AVAILABLE = 8;
  PF_SSE3_INSTRUCTIONS_AVAILABLE = 13;
  PF_XMMI_INSTRUCTIONS_AVAILABLE = 6;
  PF_XMMI64_INSTRUCTIONS_AVAILABLE = 10;
  PF_XSAVE_ENABLED = 17;
  SE_DEBUG_NAME = 'SeDebugPrivilege';

type

  TMemoryStatusEx_API = record
    dwLength : Cardinal;
    dwMemoryLoad : Cardinal;
    ullTotalPhys,
    ullAvailPhys,
    ullTotalPageFile,
    ullAvailPageFile,
    ullTotalVirtual,
    ullAvailVirtual,
    ullAvailExtendedVirtual : Array [0..7] of Byte;
    //Array [0..7] of Byte - instead API type DWORDLONG (64 bit unsign int);
    //Int64 - not exact replacement.
  end;

  TPerformance_Information_API = record
     cb,
     CommitTotal, CommitLimit, CommitPeak,
     PhysicalTotal, PhysicalAvailable,
     SystemCache,
     KernelTotal, KernelPaged, KernelNonpaged,
     PageSize,
     HandleCount,
     ProcessCount,
     ThreadCount: Cardinal;
  end;

function API_GlobalMemoryStatusEx( out lpBuffer : TMemoryStatusEx_API
): Boolean; stdcall;
external 'Kernel32.dll' name 'GlobalMemoryStatusEx';

function API_GetPerformanceInfo ( out Perf : TPerformance_Information_API;
const cb : Cardinal ) : Boolean; stdcall;
external 'PSAPI.dll' name 'GetPerformanceInfo';

function API_GetDefaultPrinterA ( pBuffer : Pointer;
var szBuffer : Cardinal ) : Boolean; stdcall;
external 'winspool.drv' name 'GetDefaultPrinterA';

implementation

end.
